import sys
import os
import math

def bin(f,maxf,n,numDocs):
    if f > 0: return 1
    else: return 0

def tf(f,maxf,n,numDocs): return f

def tfidf(f,maxf,n,numDocs):
    return f * math.log(float(numDocs)/n)

def tfidf2(f,maxf,n,numDocs):
    return float(f)/maxf * math.log(float(numDocs)/n)

gentypes = {
    '-bin' : bin,
    '-tf' : tf,
    '-tfidf' : tfidf, 
    '-tfidf2' : tfidf2, 
    }

def convert(p,stream=sys.stdout,genval=tf):
    print >>stream, """% arff file automatically generated from savedFiles from data dumped by the GATE learning plugin
@RELATION gate
"""

    cs={}
    for l in open(p + os.sep + 'LabelsList.save').readlines():
        lbl,v=l.split(' ')
        cs[v]=lbl
    print >>stream, '@ATTRIBUTE class        {%s}' % (','.join(cs.itervalues()))

    atts = {}; inDocs = {}; i = 1
    lines = open(p + os.sep + 'NLPFeatureList.save').readlines()
    numDocs=int(lines[0].split('=')[1])
    for l in lines[1:]:
        fn,index,freq=l.split(' ')
        atts[fn] = i; i+=1
        inDocs[fn] = int(freq)
        print >>stream, '@ATTRIBUTE %i NUMERIC %% %s' % (i, fn)

    maxf = {}
    if genval == tfidf2:
        f=open(p + os.sep + 'NLPFeatureData.save')
        f.readline() # skip first line
        while True:
            d=f.readline()
            if d == '': break

            id,name,count=d.split(' ')
            count=int(count)
            for i in xrange(count):
                l=f.readline(); l=l.strip()
                vs=l.split(' ')[2:]
                for v in vs:
                    k,value = v.split('<><>')
                    v=int(value)
                    if k+'<>' in maxf:
                        if v>maxf[k+'<>']: maxf[k+'<>']=v
                    else:
                        maxf[k+'<>']=v

    print >>stream, '@DATA'
    f=open(p + os.sep + 'NLPFeatureData.save')
    f.readline() # skip first line
    while True:
        d=f.readline()
        if d == '': break

        id,name,count=d.split(' ')
        count=int(count)
        for i in xrange(count):
            l=f.readline(); l=l.strip()
            vs=l.split(' ')
            c=vs[1]
            print >>stream, ('{ 0 %s' % (c.split('_')[0])),

            vs=vs[2:]
            for v in vs:
                k,value = v.split('<><>')
                if k+'<>' in atts:
                    index=atts[k+'<>']
                    ind=inDocs[k+'<>']
                    if k+'<>' in maxf: mf=maxf[k+'<>']
                    else: mf=1
                    value=genval(int(value),mf,ind,numDocs)
                    print >>stream, (', %i %s' % (index,value)),
            print >>stream, '}'


def usage():
    print 'usage: gate2arff.py [-bin|-tf|-tfidf|-tfidf2] <savedFiles-dir>'
    sys.exit(-1)

if __name__ == '__main__':
    if len(sys.argv) <= 1: usage()
    
    if sys.argv[1][0]=='-':
        try: 
            gt=gentypes[sys.argv[1]]
        except:
            print 'invalid option %s' % sys.argv[1]
            usage()
        sys.argv=sys.argv[1:]

    if len(sys.argv) > 2:
        f=open(sys.argv[2],'w')
    else:
        f=sys.stdout
    convert(sys.argv[1],f,gt)
