import gatetools
import gate
import tempfile
import java.lang

def deletePR():
    pr=gate.Factory.createResource("gate.creole.annotdelete.AnnotationDeletePR")
    return pr

def sentenceSplitter(inputAS='Original markups', outputAS='Original markups'):
    params=gate.Factory.newFeatureMap()
    params.put("inputASName", inputAS)
    params.put("outputASName", outputAS)
    pr=gate.Factory.createResource("gate.creole.splitter.SentenceSplitter", params)
    return pr

def tokenizer(AS='Original markups'):

    params=gate.Factory.newFeatureMap()
    params.put("annotationSetName",AS)
    pr=gate.Factory.createResource("gate.creole.tokeniser.SimpleTokeniser", params)
    return pr

def POSTagger(inputAS='Original markups', outputAS='Original markups'):
    params=gate.Factory.newFeatureMap()
    params.put("inputASName", inputAS)
    params.put("outputASName",outputAS)
    pr=gate.Factory.createResource("gate.creole.POSTagger", params)
    return pr


def gazetteer(url, AS='Original markups',
              sep='|', 
              caseSensitive=False, 
              longestMatchOnly=False,
              wholeWordsOnly=False):
    params=gate.Factory.newFeatureMap()
    
    params.put("gazetteerFeatureSeparator", sep)
    params.put("caseSensitive",java.lang.Boolean(caseSensitive))
    params.put("listsURL",gatetools.makeURLObj(url))
    params.put("longestMatchOnly", java.lang.Boolean(longestMatchOnly))
    params.put("wholeWordsOnly", java.lang.Boolean(wholeWordsOnly))
    params.put("annotationSetName", AS)

    pr=gate.Factory.createResource("gate.creole.gazetteer.DefaultGazetteer", params)
    return pr

def jape(url=None, rules=None, 
         inputAS='Original markups', outputAS='Original markups'):
    params=gate.Factory.newFeatureMap()
    if rules:
        url = tempfile.mktemp('.ofai-learning-tmp')
        f = open(url,'w')
        f.write(rules)
        f.close()
    params.put("grammarURL", gatetools.makeURLObj(url))
    params.put("inputASName", inputAS)
    params.put("outputASName",outputAS)
    pr=gate.Factory.createResource("gate.creole.Transducer", params)
    return pr
           

