#!/bin/bash
[ -z $SEMPRE_HOME ] && echo SEMPRE_HOME not set && exit -1
[ -z $GATE_HOME ] && GATE_HOME=/home/bjung/sempre/gate

# jython jvm arguments  (for debian)
export JAVA_OPTIONS=-Xmx3000M
# optional for debugging (i.e. starting java JDWP server)
[ "$1" == "DEBUG" ] && export JAVA_OPTIONS="-Xmx3000M -agentlib:jdwp=transport=dt_socket,address=localhost:8000,server=y"

# jython jvm arguments  (for gentoo)
export gjl_java_args="-Xmx3000M"
# optional for debugging (i.e. starting java JDWP server)
[ "$1" == "DEBUG" ] && export gjl_java_args="-Xmx3000M -agentlib:jdwp=transport=dt_socket,address=localhost:8000,server=y"

# get classpath from gate build.xml
`ant -f $GATE_HOME/build.xml run-pre | grep CLASSPATH | sed -e 's/^.*\[echo\].*CLASSPATH=/export CLASSPATH=/'`

# setup python path
export PYTHON_PATH=$SEMPRE_HOME/ofai-learning/basescripts
export CLASSPATH=$CLASSPATH:$PYTHON_PATH

# add WEKA to classpath
export CLASSPATH=$CLASSPATH:$SEMPRE_HOME/weka-3-6-1/weka.jar
export CLASSPATH=$CLASSPATH:$SEMPRE_HOME/libsvm-2.89/java/libsvm.jar

# spawn a new bash with correct environment
exec /bin/bash

