import sys
import weka
import time

# Some WEKA paramters, for libSVM
#-S 1 \ # 0 .. C-SVC, 1 .. nu-SVC \
#-K 0 \ # 0 .. linear, 1.. polynomial, 2 .. radial,  .. sigmoid kernel \
#-D 3 \ # degree in kernel funktion \
#-G 0.0 \ # gamma in kernel \
#-R 0.0 \ # coeff0 in kernel \
#-N 0.5 \ # parameter nu of nu-SVC \
#-C 1.0 \ # parameter C of C-SVC \
#-M 40.0 \ # cache memory size in MB \
#-E 0.0010 \ # tolerance of termination criterion \
#-P 0.1 \ # epsilon in loss function in eps-SVR \
#-B \ # SVC model instead of SVR
#-Z \ # \ normalization of input data

# 3 fold CV, class index 1
#-x 3 -c 1 -t /tmp/cornell10-$t-$ft.arff

# -i -k  [verbosity parameters]


# CLASSIFIER CONFIGURATION

CLASSIFIERS = (
    (weka.classifiers.functions.LibSVM, '-S 0 -K 0 -M 1024 -B -i -k'),
#    (weka.classifiers.bayes.NaiveBayes, ''),
#    (weka.classifiers.trees.J48, ''),
    (weka.classifiers.lazy.IBk, ''),
)

# File Iterator specification
pattern = "/tmp/cornell700-%s-%s.arff"
def genfiles():
    fs=[]
    for t1 in ('bin','tf','tfidf','tfidf2'):
        for t2 in ('uni','bi'):
            fs.append(pattern % (t1,t2))
    return fs

############################################################################

from java.lang import System
from java.io import File, PrintStream, FileOutputStream

def applyto(fn):
    for (klass,args) in CLASSIFIERS:
        n = klass.name.split('.')[-1]
        fnout=fn + "-%s.res" % n
        print '%s applied to %s ' % (n, fn)
        print '  output to %s' % (fnout,)
        t = time.time()
        System.setOut(PrintStream(FileOutputStream(File(fnout))))
        xargs=args.split()
        xargs.extend('-x 3 -c 1 -t '.split())
        xargs.append(fn)
        klass.main(xargs)
        d=int(time.time()-t)
        print '  %i min %i sec' % (d/60,d%60)

if len(sys.argv)==1:
    for fn in genfiles(): applyto(fn)
else:
    for fn in sys.argv[1:]: applyto(fn)

