#!/usr/bin/env jython

from config import BaseConfig
from main import Main

import learning
import process
import gate

def tagdoc(d):
    if '/pos/' in d.getSourceUrl().toString(): classlabel='pos'
    else: classlabel='neg'
    
    fs=gate.util.SimpleFeatureMapImpl()
    fs.put('rating',classlabel)
    d.getAnnotations('Original markups').add(0,d.getContent().size(),'Rating',fs)
    fs=gate.util.SimpleFeatureMapImpl()
    d.getAnnotations('Original markups').add(0,d.getContent().size(),'review_text',fs)


class MetaCritics(BaseConfig):
    dataroot = BaseConfig.dataroot + '/data/mc-split-music'
    imp_dirs = ['neg','pos']
    imp_sds = True

    storename = 'metacritics'
    steps = [process.sentenceSplitter(),
             process.tokenizer(),
             process.gazetteer(BaseConfig.dataroot+'/ofai-learning/res/SentiWordNet.def', wholeWordsOnly=True),
             process.jape(BaseConfig.dataroot+'/ofai-learning/jape/sentiwordNet.jape'),
             process.jape(BaseConfig.dataroot+'/ofai-learning/jape/pos-neg-picker.jape'),
             
             ]

m=Main(MetaCritics())
m.getCorpus(do_import=True)
m.foreach(tagdoc)
m.process()

m.learn(learning.learningSVM,learning.datasetUnigramMyTokCFG,learn=True)

m.cleanup()

