function printUsage {
    echo "usage: gen_ext_corpus.sh [700|1000] [html|title]"
    exit
}
# naming for 700:  cv321_tok-10520.txt
# naming for 1000: cv256_16529.txt
function greptitle {
    OUTDIR=$1
    CV=$2
    NR=$3
    grep -o -e '<A HREF="/Title?[^"]*">[^<]*' $MOVIEDIR/$NR.html | sed 's/<[^>]*>//g' > $OUTDIR/cv${CV}_$NR.title
}

function cpmovie() {
    OUTDIR=$1
    CV=$2
    NR=$3
    cp $MOVIEDIR/$NR.html $OUTDIR/cv${CV}_$NR.html
}

function list() {
    mkdir -p $2;
    for i in $1/*.txt; do 
	i=`basename $i`
	NR=$i; NR=${NR/cv???_/};NR=${NR/.txt/};NR=${NR/tok-/};CV=${i:2:3}; 
	$3 $2 $CV $NR; 
    done
}

if [ "$SEMPRE_HOME" == "" ]; then
    echo "SEMPRE_HOME not defined"
    exit
fi;

MOVIEDIR=$SEMPRE_HOME/data/cornell-raw/movie

case $1 in
    "700") D=$SEMPRE_HOME/data/cornell700/tokens/ ;;
    "1000") D=$SEMPRE_HOME/data/cornell1000/txt_sentoken/ ;;
    *) printUsage ;;
esac;
case $2 in
    "title") fproc=greptitle ;;
    "html") fproc=cpmovie ;;
    *) printUsage ;;
esac;

OUTDIR_ROOT=$SEMPRE_HOME/data/cornell$1-$2

rm -Rf $OUTDIR_ROOT
for t in pos neg; do
    list $D/$t $OUTDIR_ROOT/$t $fproc
    echo creating ... $OUTDIR_ROOT/$t
done
