#!/bin/bash

if [ "$1" = "" ]; then
  echo "usage: score_hist.sh [movies|music]"
  exit;
fi;

P=known\ author/url
OUTDIR=`mktemp -d -t mc-scores-XXXXXX`
T="$OUTDIR/tmp.plot"
TR="$OUTDIR/tmp.raw"
DATA="$OUTDIR/tmp.data"
LOG="$OUTDIR/data.txt"

H=$OUTDIR/stats.html

echo "<HTML><BODY>" > $H
echo "" > $LOG

dd=$SEMPRE_HOME/data/metacritics-$1

(cd "$dd"; find . -type d -print0) | while read -d $'\0' dir
do
    if [ `find "$dd/$dir" -type d | wc -l` -gt 0 ] && [ `ls "$dd/$dir" | wc -l` -gt 0 ]; then

        N=$dir
	N=${N//./_}
	N=${N// /_}
	N=${N//\//_}
	IMG=$N.svg
	echo $dir;

	echo "set output \"$OUTDIR/$IMG\"" >> $T
	echo "set terminal svg" >> $T
	echo "set boxwidth 5 absolute" >> $T
	echo "set style fill solid 1.0" >> $T
	echo "plot [0:100] [0:] '-' with boxes notitle" >> $T

	echo > $TR
	(cd "$dd/$dir"; find . -type d -print0) | while read -d $'\0' ldir
        do
	    if [ `ls "$dd/$dir/$ldir" | wc -l` -gt 0 ]; then
  		grep -h CriticRating: "$dd/$dir/$ldir/"* >> $TR
	    fi;
        done;


	#grep -h CriticRating: "$dd/$dir"/* | 
        cat $TR |
	grep -o -E "[0-9]+" | 
	sort -n | 
	uniq -c | 
	awk '{print $2 "\t" $1}' > $DATA

	echo $N >> $LOG
	cat $DATA >> $LOG

	cat $DATA >> $T
	echo "e" >> $T

	gnuplot < $T

	CNT=`wc -l < $TR`

	echo "<h3>$dir ($CNT reviews)</h3>" >> $H
	echo "<object height=\"200\" data=\"$IMG\" type=\"image/svg+xml\"><param name=\"src\" value=\"$IMG\"></object><br>" >> $H
    fi;
done;

echo "</BODY></HTML>" >> $H

rm -f $T

echo "run:"
echo "firefox $H"
echo "less $LOG"

