#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# (c) 2008 bernhard jung
# splits upenn pseudo xml files into separate documents for processing in GATE
# fixes several XML issues:
#  - & -> &amp;
#  - Unicode: 0x1a characters
#  - < > in lines

from config import upenn

import re
import os
import codecs

re_amp = re.compile("&\S*(?!;)")
re_0x1a = re.compile(u"\u001a")
re_tags = re.compile(u"<([^>]*)>")

try: os.system("rm -Rf %s"  % upenn.splitpath)
except: pass
try: os.mkdir(upenn.splitpath)
except: pass

for (filename,prefix) in upenn.conf:
    fout = None; nr = 0
    fin = codecs.open(upenn.datapath + '/' + filename, 'r', 'utf-8')
    for line in fin.readlines():
        if line.startswith('<review>'):
            if fout: fout.close()
            fout = codecs.open(upenn.splitpath + '/' + (prefix % nr),'w','utf-8')
            nr += 1

        # fix &ampersand;
        line = re_amp.sub("&amp;",line)

        # unicode 0x1a
        line = re_0x1a.sub("?", line)

        # <,> in lines
        l = line.strip()
        if len(l) > 1 and l[0] != '<' and l[-1] != '>':
            line = line.replace('<','&lt;').replace('>','&gt;')

        print >>fout, line, 
